#include<stdio.h>

#define BUFFER_SIZE 102400

typedef unsigned char byte;

unsigned char buffer[BUFFER_SIZE];

int encode(FILE *fp,byte *img,int mx);

/* main֐ */
int main(int ac,char *av[])
{
    FILE *fp_i,*fp_o;
    int i,c;

    if(ac<3) {
        exit(8);
    }
    fp_i=fopen(av[1],"rb");
    if(fp_i==NULL) {
        fprintf(stderr,"Input File cannot openn");
        exit(8);
    }
    i=0;
    while(i<BUFFER_SIZE && (c=fgetc(fp_i))!=EOF) {
        buffer[i]=c;
        i++;
    }
    fclose(fp_i);
    fp_o=fopen(av[2],"wb");
    if(fp_o==NULL) {
        fprintf(stderr,"Output File cannot openn");
        exit(8);
    }
    encode(fp_o,buffer,i);
    fclose(fp_o);
    return 0;
}

/* f[^l̕ԃ߂ */
int getRLE(byte *img,int x,int mx,int lim,int *run,int *code)
{
    int px;

    px=x;
    *run=1;
    *code=img[px];
    px++;
    while(px<mx && *code==img[px] && *run<lim ) {
        px++;
        (*run)++;
    }
    return px;
}

/* kC */
int encode(FILE *fp,byte *img,int mx)
{
    int run,code;
    int x;

    x=0;
    while(x<mx) {
        x=getRLE(img,x,mx,0xff,&run,&code);
        fputc(run,fp);
	printf("%d|%c\t",run,code);
        fputc(code,fp);
    }
    return 0;
}
